Attribute VB_Name = "MRedGreenBlue"
' *********************************************************************
'  Copyright 1995-2001, Karl E. Peterson, All Rights Reserved.
'  http://www.mvps.org/vb
' *********************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code without prior written consent.
' *********************************************************************
Option Explicit

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public Declare Function GetPixelRGB Lib "gdi32" Alias "GetPixel" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As RGB32
Public Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long

Public Type RGB32
   Red As Byte
   Green As Byte
   Blue As Byte
   Pad As Byte
End Type

' *******************************************************
'  Sling bytes into structure to break apart.
' *******************************************************
Public Function SplitColors(ByVal Value As Long) As RGB32
   Call CopyMemory(SplitColors, Value, 4)
End Function

' *******************************************************
'  Direct translation of the native C Macros, provided
'  by Brad Martinez.  http://www.mvps.org/btmtz
' *******************************************************
Public Function GetRValue(ByVal Value As Long) As Byte
  ' #define GetRValue(rgb)   ((BYTE) (rgb))
  GetRValue = (Value And &HFF)
End Function

Public Function GetGValue(ByVal Value As Long) As Byte
  ' #define GetGValue(rgb)   ((BYTE) (((WORD) (rgb)) >> 8))
  GetGValue = (Value And &HFF00&) \ &H100
End Function

Public Function GetBValue(ByVal Value As Long) As Byte
  ' #define GetBValue(rgb)   ((BYTE) ((rgb) >> 16))
  GetBValue = (Value And &HFF0000) \ &H10000
End Function

' *******************************************************
'  Ancient functions originally written for VB2, and
'  updated to return a Byte instead of Integer at VB4.
' *******************************************************
Public Function Red(ByVal Value As Long) As Byte
   Red = (Value Mod &H100)
End Function

Public Function Green(ByVal Value As Long) As Byte
   Green = (Value \ &H100) Mod &H100
End Function

Public Function Blue(ByVal Value As Long) As Byte
   Blue = (Value \ &H10000) Mod &H10000
End Function
